#include <avr/io.h>
#include <avr/interrupt.h>


.global     fkt
.global     INT0_vect
.comm       gSavedSPL, 1


//===========================================================================//
// interrupt routine for INT0
INT0_vect:

    // store Stackpointer_L in global variable
    in      r1, _SFR_IO_ADDR(SPL)
    sts     gSavedSPL, r1

    reti



//===========================================================================//
// this function is called from main()
.func fkt
fkt:

    // save registers on stack
    push    r29
    push    r28
    push    r1
    push    r0

    // r1 = 0x00
    clr     r1

    // save stackpointer
    in      r28, _SFR_IO_ADDR(SPL)
    in      r29, _SFR_IO_ADDR(SPH)

    // set the stackpointer to a silly value (= 0x0000)
    out     _SFR_IO_ADDR(SPH), r1
    out     _SFR_IO_ADDR(SPL), r1

    // save SREG, and disable all interrupts
    in      r0, _SFR_IO_ADDR(SREG)
    cli

    // raise the software interrupt on PD2
    out     _SFR_IO_ADDR(PORTD), r1

    // editorial, the workaround script swap_spl.exe needs this search pattern
    cli

    // restore Stackpointer_H with saved value
    out     _SFR_IO_ADDR(SPH),   r29

    // restore SREG, which enables all interrupts
    out     _SFR_IO_ADDR(SREG),  r0

	// At this time the VMLAB malfunction occurs !
	// The real microprocessor executes the next command (SPL), before
	// it handles the interrupt.
	// VMLAB immediately handles the interrupt, i.e. Stackpointer_L
	// will be restored afterwards. Without the correct stackpointer,
	// the program pointer is stored elsewhere when entering the
	// interrupt routine - this can lead to unpredictable behaviour. 

    // restore Stackpointer_L with saved value
    out     _SFR_IO_ADDR(SPL),   r28

    // restore registers from stack
    pop     r0
    pop     r1
    pop     r28
    pop     r29

    ret

.endfunc

.end
