#include <avr\io.h>
#include <avr\interrupt.h>


// in assembler file //
extern int8_t   gSavedSPL;
extern void     fkt (void);


// ***********************************************************
int main(void)
{
    volatile int    StackPtr_is_wrong;


    // configure INT0 interrupt as a software interrupt
    DDRD    |= (1<<PD2);        // PD2 (INT0) as output
    PORTD   |= (1<<PD2);        // PD2 = 1

    MCUCR   |= (1<<ISC01);      // falling edge at PD2 shall raise INT0

    GICR    |= (1<<INT0);       // enable INT0

    sei();                      // global enable all interrupts
    

    // Call the assembler function. 
    // INT0 is raised inside this function, too.
    // Inside the interrupt routine, the low part of the stackpointer is stored in gSavedSPL.
    fkt ();


    // After returning from the assembler function and from the interrupt routine,
    // check the stored low part of the stackpointer.
    if (gSavedSPL == -2)
    {
        StackPtr_is_wrong = 1;          // good place to set a breakpoint :-)
    }
    else
    {
        StackPtr_is_wrong = 0;          // good place to set a breakpoint :-)
    }


    while (1);
}

